import{S as Zt,i as ea,s as ta,e as o,k as f,w as Ht,t as i,M as aa,c as r,d as a,m as h,a as l,x as Jt,h as n,b as m,G as e,g as d,y as Kt,L as oa,q as Qt,o as Vt,B as Xt,v as ra}from"../../chunks/vendor-hf-doc-builder.js";import{I as Yt}from"../../chunks/IconCopyLink-hf-doc-builder.js";function la(yt){let w,ne,b,A,W,T,ge,B,Ee,se,u,ke,L,Te,Le,D,Pe,Ce,de,O,$e,fe,F,xe,he,c,G,De,Oe,U,Fe,Re,H,ze,Se,J,Me,me,R,qe,ce,y,I,K,P,Ne,Q,je,pe,z,We,ue,p,V,Be,Ge,C,Ue,X,He,Je,Ke,_,Qe,Y,Ve,Xe,Z,Ye,Ze,et,$,tt,ee,at,ot,ve,x,te,rt,lt,we,v,S,ae,it,nt,st,g,oe,dt,ft,re,ht,mt,ct,M,le,pt,ut,be;return T=new Yt({}),P=new Yt({}),{c(){w=o("meta"),ne=f(),b=o("h1"),A=o("a"),W=o("span"),Ht(T.$$.fragment),ge=f(),B=o("span"),Ee=i("IA3"),se=f(),u=o("p"),ke=i("This conceptual guide gives a brief overview of "),L=o("a"),Te=i("IA3"),Le=i(`, a parameter-efficient fine tuning technique that is
intended to improve over `),D=o("a"),Pe=i("LoRA"),Ce=i("."),de=f(),O=o("p"),$e=i(`To make fine-tuning more efficient, IA3 (Infused Adapter by Inhibiting and Amplifying Inner Activations)
rescales inner activations with learned vectors. These learned vectors are injected in the attention and feedforward modules
in a typical transformer-based architecture. These learned vectors are the only trainable parameters during fine-tuning, and thus the original
weights remain frozen. Dealing with learned vectors (as opposed to learned low-rank updates to a weight matrix like LoRA)
keeps the number of trainable parameters much smaller.`),fe=f(),F=o("p"),xe=i("Being similar to LoRA, IA3 carries many of the same advantages:"),he=f(),c=o("ul"),G=o("li"),De=i("IA3 makes fine-tuning more efficient by drastically reducing the number of trainable parameters. (For T0, an IA3 model only has about 0.01% trainable parameters, while even LoRA has > 0.1%)"),Oe=f(),U=o("li"),Fe=i("The original pre-trained weights are kept frozen, which means you can have multiple lightweight and portable IA3 models for various downstream tasks built on top of them."),Re=f(),H=o("li"),ze=i("Performance of models fine-tuned using IA3 is comparable to the performance of fully fine-tuned models."),Se=f(),J=o("li"),Me=i("IA3 does not add any inference latency because adapter weights can be merged with the base model."),me=f(),R=o("p"),qe=i(`In principle, IA3 can be applied to any subset of weight matrices in a neural network to reduce the number of trainable
parameters. Following the authors\u2019 implementation, IA3 weights are added to the key, value and feedforward layers
of a Transformer model. Given the target layers for injecting IA3 parameters, the number of trainable parameters
can be determined based on the size of the weight matrices.`),ce=f(),y=o("h2"),I=o("a"),K=o("span"),Ht(P.$$.fragment),Ne=f(),Q=o("span"),je=i("Common IA3 parameters in PEFT"),pe=f(),z=o("p"),We=i("As with other methods supported by PEFT, to fine-tune a model using IA3, you need to:"),ue=f(),p=o("ol"),V=o("li"),Be=i("Instantiate a base model."),Ge=f(),C=o("li"),Ue=i("Create a configuration ("),X=o("code"),He=i("IA3Config"),Je=i(") where you define IA3-specific parameters."),Ke=f(),_=o("li"),Qe=i("Wrap the base model with "),Y=o("code"),Ve=i("get_peft_model()"),Xe=i(" to get a trainable "),Z=o("code"),Ye=i("PeftModel"),Ze=i("."),et=f(),$=o("li"),tt=i("Train the "),ee=o("code"),at=i("PeftModel"),ot=i(" as you normally would train the base model."),ve=f(),x=o("p"),te=o("code"),rt=i("IA3Config"),lt=i(" allows you to control how IA3 is applied to the base model through the following parameters:"),we=f(),v=o("ul"),S=o("li"),ae=o("code"),it=i("target_modules"),nt=i(": The modules (for example, attention blocks) to apply the IA3 vectors."),st=f(),g=o("li"),oe=o("code"),dt=i("feedforward_modules"),ft=i(": The list of modules to be treated as feedforward layers in "),re=o("code"),ht=i("target_modules"),mt=i(`. While learned vectors are multiplied with
the output activation for attention blocks, the vectors are multiplied with the input for classic feedforward layers.`),ct=f(),M=o("li"),le=o("code"),pt=i("modules_to_save"),ut=i(": List of modules apart from IA3 layers to be set as trainable and saved in the final checkpoint. These typically include model\u2019s custom head that is randomly initialized for the fine-tuning task."),this.h()},l(t){const s=aa('[data-svelte="svelte-1phssyn"]',document.head);w=r(s,"META",{name:!0,content:!0}),s.forEach(a),ne=h(t),b=r(t,"H1",{class:!0});var ye=l(b);A=r(ye,"A",{id:!0,class:!0,href:!0});var _t=l(A);W=r(_t,"SPAN",{});var At=l(W);Jt(T.$$.fragment,At),At.forEach(a),_t.forEach(a),ge=h(ye),B=r(ye,"SPAN",{});var It=l(B);Ee=n(It,"IA3"),It.forEach(a),ye.forEach(a),se=h(t),u=r(t,"P",{});var q=l(u);ke=n(q,"This conceptual guide gives a brief overview of "),L=r(q,"A",{href:!0,rel:!0});var gt=l(L);Te=n(gt,"IA3"),gt.forEach(a),Le=n(q,`, a parameter-efficient fine tuning technique that is
intended to improve over `),D=r(q,"A",{href:!0});var Et=l(D);Pe=n(Et,"LoRA"),Et.forEach(a),Ce=n(q,"."),q.forEach(a),de=h(t),O=r(t,"P",{});var kt=l(O);$e=n(kt,`To make fine-tuning more efficient, IA3 (Infused Adapter by Inhibiting and Amplifying Inner Activations)
rescales inner activations with learned vectors. These learned vectors are injected in the attention and feedforward modules
in a typical transformer-based architecture. These learned vectors are the only trainable parameters during fine-tuning, and thus the original
weights remain frozen. Dealing with learned vectors (as opposed to learned low-rank updates to a weight matrix like LoRA)
keeps the number of trainable parameters much smaller.`),kt.forEach(a),fe=h(t),F=r(t,"P",{});var Tt=l(F);xe=n(Tt,"Being similar to LoRA, IA3 carries many of the same advantages:"),Tt.forEach(a),he=h(t),c=r(t,"UL",{});var E=l(c);G=r(E,"LI",{});var Lt=l(G);De=n(Lt,"IA3 makes fine-tuning more efficient by drastically reducing the number of trainable parameters. (For T0, an IA3 model only has about 0.01% trainable parameters, while even LoRA has > 0.1%)"),Lt.forEach(a),Oe=h(E),U=r(E,"LI",{});var Pt=l(U);Fe=n(Pt,"The original pre-trained weights are kept frozen, which means you can have multiple lightweight and portable IA3 models for various downstream tasks built on top of them."),Pt.forEach(a),Re=h(E),H=r(E,"LI",{});var Ct=l(H);ze=n(Ct,"Performance of models fine-tuned using IA3 is comparable to the performance of fully fine-tuned models."),Ct.forEach(a),Se=h(E),J=r(E,"LI",{});var $t=l(J);Me=n($t,"IA3 does not add any inference latency because adapter weights can be merged with the base model."),$t.forEach(a),E.forEach(a),me=h(t),R=r(t,"P",{});var xt=l(R);qe=n(xt,`In principle, IA3 can be applied to any subset of weight matrices in a neural network to reduce the number of trainable
parameters. Following the authors\u2019 implementation, IA3 weights are added to the key, value and feedforward layers
of a Transformer model. Given the target layers for injecting IA3 parameters, the number of trainable parameters
can be determined based on the size of the weight matrices.`),xt.forEach(a),ce=h(t),y=r(t,"H2",{class:!0});var _e=l(y);I=r(_e,"A",{id:!0,class:!0,href:!0});var Dt=l(I);K=r(Dt,"SPAN",{});var Ot=l(K);Jt(P.$$.fragment,Ot),Ot.forEach(a),Dt.forEach(a),Ne=h(_e),Q=r(_e,"SPAN",{});var Ft=l(Q);je=n(Ft,"Common IA3 parameters in PEFT"),Ft.forEach(a),_e.forEach(a),pe=h(t),z=r(t,"P",{});var Rt=l(z);We=n(Rt,"As with other methods supported by PEFT, to fine-tune a model using IA3, you need to:"),Rt.forEach(a),ue=h(t),p=r(t,"OL",{});var k=l(p);V=r(k,"LI",{});var zt=l(V);Be=n(zt,"Instantiate a base model."),zt.forEach(a),Ge=h(k),C=r(k,"LI",{});var Ae=l(C);Ue=n(Ae,"Create a configuration ("),X=r(Ae,"CODE",{});var St=l(X);He=n(St,"IA3Config"),St.forEach(a),Je=n(Ae,") where you define IA3-specific parameters."),Ae.forEach(a),Ke=h(k),_=r(k,"LI",{});var N=l(_);Qe=n(N,"Wrap the base model with "),Y=r(N,"CODE",{});var Mt=l(Y);Ve=n(Mt,"get_peft_model()"),Mt.forEach(a),Xe=n(N," to get a trainable "),Z=r(N,"CODE",{});var qt=l(Z);Ye=n(qt,"PeftModel"),qt.forEach(a),Ze=n(N,"."),N.forEach(a),et=h(k),$=r(k,"LI",{});var Ie=l($);tt=n(Ie,"Train the "),ee=r(Ie,"CODE",{});var Nt=l(ee);at=n(Nt,"PeftModel"),Nt.forEach(a),ot=n(Ie," as you normally would train the base model."),Ie.forEach(a),k.forEach(a),ve=h(t),x=r(t,"P",{});var vt=l(x);te=r(vt,"CODE",{});var jt=l(te);rt=n(jt,"IA3Config"),jt.forEach(a),lt=n(vt," allows you to control how IA3 is applied to the base model through the following parameters:"),vt.forEach(a),we=h(t),v=r(t,"UL",{});var j=l(v);S=r(j,"LI",{});var wt=l(S);ae=r(wt,"CODE",{});var Wt=l(ae);it=n(Wt,"target_modules"),Wt.forEach(a),nt=n(wt,": The modules (for example, attention blocks) to apply the IA3 vectors."),wt.forEach(a),st=h(j),g=r(j,"LI",{});var ie=l(g);oe=r(ie,"CODE",{});var Bt=l(oe);dt=n(Bt,"feedforward_modules"),Bt.forEach(a),ft=n(ie,": The list of modules to be treated as feedforward layers in "),re=r(ie,"CODE",{});var Gt=l(re);ht=n(Gt,"target_modules"),Gt.forEach(a),mt=n(ie,`. While learned vectors are multiplied with
the output activation for attention blocks, the vectors are multiplied with the input for classic feedforward layers.`),ie.forEach(a),ct=h(j),M=r(j,"LI",{});var bt=l(M);le=r(bt,"CODE",{});var Ut=l(le);pt=n(Ut,"modules_to_save"),Ut.forEach(a),ut=n(bt,": List of modules apart from IA3 layers to be set as trainable and saved in the final checkpoint. These typically include model\u2019s custom head that is randomly initialized for the fine-tuning task."),bt.forEach(a),j.forEach(a),this.h()},h(){m(w,"name","hf:doc:metadata"),m(w,"content",JSON.stringify(ia)),m(A,"id","ia3"),m(A,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(A,"href","#ia3"),m(b,"class","relative group"),m(L,"href","https://arxiv.org/abs/2205.05638"),m(L,"rel","nofollow"),m(D,"href","./lora"),m(I,"id","common-ia3-parameters-in-peft"),m(I,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(I,"href","#common-ia3-parameters-in-peft"),m(y,"class","relative group")},m(t,s){e(document.head,w),d(t,ne,s),d(t,b,s),e(b,A),e(A,W),Kt(T,W,null),e(b,ge),e(b,B),e(B,Ee),d(t,se,s),d(t,u,s),e(u,ke),e(u,L),e(L,Te),e(u,Le),e(u,D),e(D,Pe),e(u,Ce),d(t,de,s),d(t,O,s),e(O,$e),d(t,fe,s),d(t,F,s),e(F,xe),d(t,he,s),d(t,c,s),e(c,G),e(G,De),e(c,Oe),e(c,U),e(U,Fe),e(c,Re),e(c,H),e(H,ze),e(c,Se),e(c,J),e(J,Me),d(t,me,s),d(t,R,s),e(R,qe),d(t,ce,s),d(t,y,s),e(y,I),e(I,K),Kt(P,K,null),e(y,Ne),e(y,Q),e(Q,je),d(t,pe,s),d(t,z,s),e(z,We),d(t,ue,s),d(t,p,s),e(p,V),e(V,Be),e(p,Ge),e(p,C),e(C,Ue),e(C,X),e(X,He),e(C,Je),e(p,Ke),e(p,_),e(_,Qe),e(_,Y),e(Y,Ve),e(_,Xe),e(_,Z),e(Z,Ye),e(_,Ze),e(p,et),e(p,$),e($,tt),e($,ee),e(ee,at),e($,ot),d(t,ve,s),d(t,x,s),e(x,te),e(te,rt),e(x,lt),d(t,we,s),d(t,v,s),e(v,S),e(S,ae),e(ae,it),e(S,nt),e(v,st),e(v,g),e(g,oe),e(oe,dt),e(g,ft),e(g,re),e(re,ht),e(g,mt),e(v,ct),e(v,M),e(M,le),e(le,pt),e(M,ut),be=!0},p:oa,i(t){be||(Qt(T.$$.fragment,t),Qt(P.$$.fragment,t),be=!0)},o(t){Vt(T.$$.fragment,t),Vt(P.$$.fragment,t),be=!1},d(t){a(w),t&&a(ne),t&&a(b),Xt(T),t&&a(se),t&&a(u),t&&a(de),t&&a(O),t&&a(fe),t&&a(F),t&&a(he),t&&a(c),t&&a(me),t&&a(R),t&&a(ce),t&&a(y),Xt(P),t&&a(pe),t&&a(z),t&&a(ue),t&&a(p),t&&a(ve),t&&a(x),t&&a(we),t&&a(v)}}}const ia={local:"ia3",sections:[{local:"common-ia3-parameters-in-peft",title:"Common IA3 parameters in PEFT"}],title:"IA3 "};function na(yt){return ra(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class fa extends Zt{constructor(w){super();ea(this,w,na,la,ta,{})}}export{fa as default,ia as metadata};
